// ---------- Attention: Generated code, please do not modify! -----------  

/*
 * Licensed to the Apache Software Foundation (ASF) under one or more
 * contributor license agreements.  See the NOTICE file distributed with
 * this work for additional information regarding copyright ownership.
 * The ASF licenses this file to You under the Apache License, Version 2.0
 * (the "License"); you may not use this file except in compliance with
 * the License.  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.myfaces.tobago.component;

import javax.el.MethodExpression;
import javax.faces.context.FacesContext;
import org.apache.myfaces.tobago.context.Markup;
import org.apache.myfaces.tobago.event.SortActionSource2;
import org.apache.myfaces.tobago.internal.component.AbstractUISheet;
import org.apache.myfaces.tobago.layout.Display;
import org.apache.myfaces.tobago.layout.Measure;
import org.apache.myfaces.tobago.internal.util.ArrayUtils;
import org.apache.myfaces.tobago.internal.util.StringUtils;
import org.apache.myfaces.tobago.internal.util.Deprecation;
import org.apache.myfaces.tobago.renderkit.MarginValues;
import org.apache.myfaces.tobago.renderkit.SpacingValues;
import org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer;
import javax.el.ELException;
import javax.faces.FacesException;
import java.util.ArrayList;
import java.util.List;
import javax.el.MethodExpression;
import javax.el.ValueExpression;

/** 
 Render a sheet element.
  * UIComponent class, generated from template {@code component2.0.stg} with class
  * {@link org.apache.myfaces.tobago.internal.taglib.component.SheetTagDeclaration}.
 */
public class UISheet
    extends AbstractUISheet implements SortActionSource2, SupportsMarkup {

  public static final String COMPONENT_TYPE = "org.apache.myfaces.tobago.Sheet";

  public static final String COMPONENT_FAMILY = "javax.faces.Data";

  private org.apache.myfaces.tobago.context.Markup currentMarkup;

  enum PropertyKeys {
    preferredWidth,
    horizontalIndex,
    paddingRight,
    selectable,
    showDirectLinks,
    preferredHeight,
    marginRight,
    borderLeft,
    paddingBottom,
    currentHeight,
    borderBottom,
    height,
    markup,
    showPagingAlways,
    directLinkCount,
    showRootJunction,
    showPageRangeArrows,
    showDirectLinksArrows,
    marginLeft,
    overflowX,
    showRoot,
    overflowY,
    showRowRange,
    left,
    borderRight,
    marginBottom,
    paddingLeft,
    columnSpan,
    showPageRange,
    columns,
    borderTop,
    top,
    currentWidth,
    maximumWidth,
    paddingTop,
    stateChangeListener,
    rowSpan,
    showHeader,
    display,
    sortActionListener,
    minimumHeight,
    renderedPartially,
    width,
    forceVerticalScrollbar,
    maximumHeight,
    verticalIndex,
    minimumWidth,
    marginTop,
  }

  public String getFamily() {
    return COMPONENT_FAMILY;
  }


  public org.apache.myfaces.tobago.layout.Measure getPreferredWidth() {
    Object object = getStateHelper().eval(PropertyKeys.preferredWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredWidth(org.apache.myfaces.tobago.layout.Measure preferredWidth) {
    getStateHelper().put(PropertyKeys.preferredWidth, preferredWidth);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getHorizontalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.horizontalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setHorizontalIndex(java.lang.Integer horizontalIndex) {
    getStateHelper().put(PropertyKeys.horizontalIndex, horizontalIndex);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingRight() {
    Object object = getStateHelper().eval(PropertyKeys.paddingRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingRight(org.apache.myfaces.tobago.layout.Measure paddingRight) {
    getStateHelper().put(PropertyKeys.paddingRight, paddingRight);
  }

  /**
  Flag indicating whether or not the sheet should be selectable.
  <br />Default: <code>multi</code><br />Allowed Values: <code>none,single,singleOrNone,multi</code>
  */
  public java.lang.String getSelectable() {
    java.lang.String selectable = (java.lang.String) getStateHelper().eval(PropertyKeys.selectable);
    if (selectable != null) {
      return selectable;
    }
    return "multi";
  }

  public void setSelectable(java.lang.String selectable) {
    getStateHelper().put(PropertyKeys.selectable, selectable);
  }

  /**
  Flag indicating whether or not a range of direct paging links should be rendered in the sheet's footer.
  <br />Default: <code>center</code><br />Allowed Values: <code>left,center,right,none</code>
  */
  public java.lang.String getShowDirectLinks() {
    java.lang.String showDirectLinks = (java.lang.String) getStateHelper().eval(PropertyKeys.showDirectLinks);
    if (showDirectLinks != null) {
      return showDirectLinks;
    }
    return "center";
  }

  public void setShowDirectLinks(java.lang.String showDirectLinks) {
    getStateHelper().put(PropertyKeys.showDirectLinks, showDirectLinks);
  }

  public org.apache.myfaces.tobago.layout.Measure getPreferredHeight() {
    Object object = getStateHelper().eval(PropertyKeys.preferredHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getPreferredHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPreferredHeight(org.apache.myfaces.tobago.layout.Measure preferredHeight) {
    getStateHelper().put(PropertyKeys.preferredHeight, preferredHeight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginRight() {
    Object object = getStateHelper().eval(PropertyKeys.marginRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginRight(org.apache.myfaces.tobago.layout.Measure marginRight) {
    getStateHelper().put(PropertyKeys.marginRight, marginRight);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderLeft() {
    Object object = getStateHelper().eval(PropertyKeys.borderLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
   getRenderer(getFacesContext())).getBorderLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderLeft(org.apache.myfaces.tobago.layout.Measure borderLeft) {
    getStateHelper().put(PropertyKeys.borderLeft, borderLeft);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingBottom() {
    Object object = getStateHelper().eval(PropertyKeys.paddingBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingBottom(org.apache.myfaces.tobago.layout.Measure paddingBottom) {
    getStateHelper().put(PropertyKeys.paddingBottom, paddingBottom);
  }

  /**
  This value will usually be set by the layout manager. It holds the current height computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentHeight() {
    Object object = getStateHelper().eval(PropertyKeys.currentHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getHeight();
  }

  public void setCurrentHeight(org.apache.myfaces.tobago.layout.Measure currentHeight) {
    getStateHelper().put(PropertyKeys.currentHeight, currentHeight);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderBottom() {
    Object object = getStateHelper().eval(PropertyKeys.borderBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderBottom(org.apache.myfaces.tobago.layout.Measure borderBottom) {
    getStateHelper().put(PropertyKeys.borderBottom, borderBottom);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getHeight() {
    Object object = getStateHelper().eval(PropertyKeys.height);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setHeight(org.apache.myfaces.tobago.layout.Measure height) {
    getStateHelper().put(PropertyKeys.height, height);
  }

  public org.apache.myfaces.tobago.context.Markup getMarkup() {
    Object object = getStateHelper().eval(PropertyKeys.markup);
    if (object != null) {
      return Markup.valueOf(object);
    }
    return null;
  }

  public void setMarkup(org.apache.myfaces.tobago.context.Markup markup) {
    getStateHelper().put(PropertyKeys.markup, markup);
  }

  /**
  Flag indicating whether or not the paging panel should be display, if it is not needed for paging.<br />
   <ul>
   <li>showPagingAlways="false" which is the default means, that the paging footer should be displayed,
   only when it is needed.</li>
   <ul>
   <li>When the rows="0" paging is not needed, so the footer will not be rendered,</li>
   <li>when rows="N", N &gt; 0 and the size of the data value is &lt;= N paging is not needed
   and the footer will not be rendered,</li>
   <li>in any other case the paging footer will be displayed.</li>
   </ul>
   <li>showPagingAlways="true" means, that the paging footer should be displayed in any case.</li>
   </ul>
  <br />Default: <code>false</code>
  */
  public boolean isShowPagingAlways() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showPagingAlways);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowPagingAlways(boolean showPagingAlways) {
    getStateHelper().put(PropertyKeys.showPagingAlways, showPagingAlways);
  }

  /**
  The count of rendered direct paging links in the sheet's footer.<br />
  <br />Default: <code>9</code>
  */
  public java.lang.Integer getDirectLinkCount() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.directLinkCount);
    if (value != null) {
      return value.intValue();
    }
    return 9;
  }

  public void setDirectLinkCount(java.lang.Integer directLinkCount) {
    getStateHelper().put(PropertyKeys.directLinkCount, directLinkCount);
  }

  /**
  Only applicable in the case that the data model is a tree. This flag indicates that the root node should be
   displayed with an open-close-switch.
  <br />Default: <code>false</code>
  */
  public boolean isShowRootJunction() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRootJunction);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRootJunction(boolean showRootJunction) {
    getStateHelper().put(PropertyKeys.showRootJunction, showRootJunction);
  }

  /**
  Flag indicating if paging arrows are shown near page range
  <br />Default: <code>true</code>
  */
  public boolean isShowPageRangeArrows() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showPageRangeArrows);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowPageRangeArrows(boolean showPageRangeArrows) {
    getStateHelper().put(PropertyKeys.showPageRangeArrows, showPageRangeArrows);
  }

  /**
  Flag indicating if paging arrows are shown near direct links
  <br />Default: <code>false</code>
  */
  public boolean isShowDirectLinksArrows() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showDirectLinksArrows);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowDirectLinksArrows(boolean showDirectLinksArrows) {
    getStateHelper().put(PropertyKeys.showDirectLinksArrows, showDirectLinksArrows);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginLeft() {
    Object object = getStateHelper().eval(PropertyKeys.marginLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginLeft(org.apache.myfaces.tobago.layout.Measure marginLeft) {
    getStateHelper().put(PropertyKeys.marginLeft, marginLeft);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowX() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowX);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowX(boolean overflowX) {
    getStateHelper().put(PropertyKeys.overflowX, overflowX);
  }

  /**
  Only applicable in the case that the data model is a tree. This flag indicates that the root node should be
   displayed. Often in tree structures the root node is special and should not be displayed.
  <br />Default: <code>false</code>
  */
  public boolean isShowRoot() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showRoot);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setShowRoot(boolean showRoot) {
    getStateHelper().put(PropertyKeys.showRoot, showRoot);
  }

  /**
  This attribute is for internal use only.

  */
  public boolean isOverflowY() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.overflowY);
    if (bool != null) {
      return bool;
    }
    return false;
  }

  public void setOverflowY(boolean overflowY) {
    getStateHelper().put(PropertyKeys.overflowY, overflowY);
  }

  /**
  Flag indicating whether or not the range of displayed rows should rendered in the sheet's footer. Rendering this
   range also offers the capability to enter the index of the start row directly.
  <br />Default: <code>left</code><br />Allowed Values: <code>left,center,right,none</code>
  */
  public java.lang.String getShowRowRange() {
    java.lang.String showRowRange = (java.lang.String) getStateHelper().eval(PropertyKeys.showRowRange);
    if (showRowRange != null) {
      return showRowRange;
    }
    return "left";
  }

  public void setShowRowRange(java.lang.String showRowRange) {
    getStateHelper().put(PropertyKeys.showRowRange, showRowRange);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getLeft() {
    Object object = getStateHelper().eval(PropertyKeys.left);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setLeft(org.apache.myfaces.tobago.layout.Measure left) {
    getStateHelper().put(PropertyKeys.left, left);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderRight() {
    Object object = getStateHelper().eval(PropertyKeys.borderRight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderRight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderRight(org.apache.myfaces.tobago.layout.Measure borderRight) {
    getStateHelper().put(PropertyKeys.borderRight, borderRight);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginBottom() {
    Object object = getStateHelper().eval(PropertyKeys.marginBottom);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginBottom(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginBottom(org.apache.myfaces.tobago.layout.Measure marginBottom) {
    getStateHelper().put(PropertyKeys.marginBottom, marginBottom);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingLeft() {
    Object object = getStateHelper().eval(PropertyKeys.paddingLeft);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingLeft(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingLeft(org.apache.myfaces.tobago.layout.Measure paddingLeft) {
    getStateHelper().put(PropertyKeys.paddingLeft, paddingLeft);
  }

  public java.lang.Integer getColumnSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.columnSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setColumnSpan(java.lang.Integer columnSpan) {
    getStateHelper().put(PropertyKeys.columnSpan, columnSpan);
  }

  /**
  Flag indicating whether and where the range pages should rendered in the sheet's footer. Rendering this range also
   offers the capability to enter the index displayed page directly.
  <br />Default: <code>right</code><br />Allowed Values: <code>left,center,right,none</code>
  */
  public java.lang.String getShowPageRange() {
    java.lang.String showPageRange = (java.lang.String) getStateHelper().eval(PropertyKeys.showPageRange);
    if (showPageRange != null) {
      return showPageRange;
    }
    return "right";
  }

  public void setShowPageRange(java.lang.String showPageRange) {
    getStateHelper().put(PropertyKeys.showPageRange, showPageRange);
  }

  /**
  LayoutConstraints for column layout. Semicolon separated list of layout tokens ('&lt;x>*', '&lt;x>px' or
   '&lt;x>%').

  */
  public java.lang.String getColumns() {
    return (java.lang.String) getStateHelper().eval(PropertyKeys.columns);
  }

  public void setColumns(java.lang.String columns) {
    getStateHelper().put(PropertyKeys.columns, columns);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getBorderTop() {
    Object object = getStateHelper().eval(PropertyKeys.borderTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getBorderTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setBorderTop(org.apache.myfaces.tobago.layout.Measure borderTop) {
    getStateHelper().put(PropertyKeys.borderTop, borderTop);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getTop() {
    Object object = getStateHelper().eval(PropertyKeys.top);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return null;
  }

  public void setTop(org.apache.myfaces.tobago.layout.Measure top) {
    getStateHelper().put(PropertyKeys.top, top);
  }

  /**
  This value will usually be set by the layout manager. It holds the current width computed by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getCurrentWidth() {
    Object object = getStateHelper().eval(PropertyKeys.currentWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getWidth();
  }

  public void setCurrentWidth(org.apache.myfaces.tobago.layout.Measure currentWidth) {
    getStateHelper().put(PropertyKeys.currentWidth, currentWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.maximumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumWidth(org.apache.myfaces.tobago.layout.Measure maximumWidth) {
    getStateHelper().put(PropertyKeys.maximumWidth, maximumWidth);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Measure getPaddingTop() {
    Object object = getStateHelper().eval(PropertyKeys.paddingTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((org.apache.myfaces.tobago.renderkit.LayoutComponentRenderer)
  getRenderer(getFacesContext())).getPaddingTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setPaddingTop(org.apache.myfaces.tobago.layout.Measure paddingTop) {
    getStateHelper().put(PropertyKeys.paddingTop, paddingTop);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getStateChangeListener() {
    javax.el.MethodExpression expression = getStateChangeListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setStateChangeListener(javax.faces.el.MethodBinding stateChangeListener) {
    if (stateChangeListener != null) {
      setStateChangeListenerExpression(new MethodBindingToMethodExpression(stateChangeListener));
    } else {
      setStateChangeListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getStateChangeListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.stateChangeListener);
  }

  public void setStateChangeListenerExpression(javax.el.MethodExpression stateChangeListener) {
    getStateHelper().put(PropertyKeys.stateChangeListener, stateChangeListener);
  }


  public java.lang.Integer getRowSpan() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.rowSpan);
    if (value != null) {
      return value.intValue();
    }
    return 1;
  }

  public void setRowSpan(java.lang.Integer rowSpan) {
    getStateHelper().put(PropertyKeys.rowSpan, rowSpan);
  }

  /**
  Flag indicating the header should be rendered.
  <br />Default: <code>true</code>
  */
  public boolean isShowHeader() {
    Boolean bool = (Boolean) getStateHelper().eval(PropertyKeys.showHeader);
    if (bool != null) {
      return bool;
    }
    return true;
  }

  public void setShowHeader(boolean showHeader) {
    getStateHelper().put(PropertyKeys.showHeader, showHeader);
  }

  /**
  This attribute is for internal use only.

  */
  public org.apache.myfaces.tobago.layout.Display getDisplay() {
    return (org.apache.myfaces.tobago.layout.Display) getStateHelper().eval(PropertyKeys.display);
  }

  public void setDisplay(org.apache.myfaces.tobago.layout.Display display) {
    getStateHelper().put(PropertyKeys.display, display);
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public javax.faces.el.MethodBinding getSortActionListener() {
    javax.el.MethodExpression expression = getSortActionListenerExpression();
    if (expression instanceof MethodBindingToMethodExpression) {
      return ((MethodBindingToMethodExpression)expression).getMethodBinding();
    }
    if (expression != null) {
       return new MethodExpressionToMethodBinding(expression);
    }
    return null;
  }

  /**
   * @deprecated since 2.0.0
   */
  @Deprecated
  public void setSortActionListener(javax.faces.el.MethodBinding sortActionListener) {
    if (sortActionListener != null) {
      setSortActionListenerExpression(new MethodBindingToMethodExpression(sortActionListener));
    } else {
      setSortActionListenerExpression(null);
    }
  }

  public javax.el.MethodExpression getSortActionListenerExpression() {
    return (javax.el.MethodExpression) getStateHelper().eval(PropertyKeys.sortActionListener);
  }

  public void setSortActionListenerExpression(javax.el.MethodExpression sortActionListener) {
    getStateHelper().put(PropertyKeys.sortActionListener, sortActionListener);
  }


  public org.apache.myfaces.tobago.layout.Measure getMinimumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.minimumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumHeight(org.apache.myfaces.tobago.layout.Measure minimumHeight) {
    getStateHelper().put(PropertyKeys.minimumHeight, minimumHeight);
  }

  public org.apache.myfaces.tobago.context.Markup getCurrentMarkup() {
    if (currentMarkup != null) {
      return currentMarkup;
    }
    return null;
  }

  public void setCurrentMarkup(org.apache.myfaces.tobago.context.Markup currentMarkup) {
    this.currentMarkup = currentMarkup;
  }

  /**
  <p>
   Indicate the partially rendered components in a case of a submit.
   </p>
   <p>
   The search depends on the number of prefixed colons in the relativeId:
   <dl>
     <dd>number of prefixed colons == 0</dd>
     <dt>fully relative</dt>
     <dd>number of prefixed colons == 1</dd>
     <dt>absolute (still normal findComponent syntax)</dt>
     <dd>number of prefixed colons == 2</dd>
     <dt>search in the current naming container (same as 0 colons)</dt>
     <dd>number of prefixed colons == 3</dd>
     <dt>search in the parent naming container of the current naming container</dt>
     <dd>number of prefixed colons > 3</dd>
     <dt>go to the next parent naming container for each additional colon</dt>
   </dl>
   </p>
   <p>
   If a literal is specified: to use more than one identifier the identifiers must be space delimited.
   </p>
   <p>
   Using this in a UISheet or UITabGroup component this list indicates components to update when calling
   internal AJAX requests like sort or paging commands.
   Don't forget to add the sheet-id or tagGroup-id in that case, if needed.
   </p>
   <p>
   You can also use

  */
  public String[] getRenderedPartially() {
    Object strArray = getStateHelper().eval(PropertyKeys.renderedPartially);
    if (strArray != null) {
      if (strArray instanceof String[]) {
        return (String[]) strArray;
      } else if (strArray instanceof String) {
        String[] strings = StringUtils.split((String) strArray, ", ");
        List<String> result = new ArrayList<String>(strings.length);
        for (String string : strings) {
          if (string.trim().length() != 0) {
            result.add(string.trim());
          }
        }
        return result.toArray(new String[result.size()]);
      } else if (strArray == null) {
        return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
      } else {
        return new String[]{strArray.toString()};
      }
    }
    return org.apache.myfaces.tobago.internal.util.ArrayUtils.EMPTY_STRING_ARRAY;
  }

  public void setRenderedPartially(String[] renderedPartially) {
    getStateHelper().put(PropertyKeys.renderedPartially, renderedPartially);
  }

  /**
  This value will usually be set by the layout manager.

  */
  public org.apache.myfaces.tobago.layout.Measure getWidth() {
    Object object = getStateHelper().eval(PropertyKeys.width);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setWidth(org.apache.myfaces.tobago.layout.Measure width) {
    getStateHelper().put(PropertyKeys.width, width);
  }

  /**
  Flag indicating whether or not this sheet should reserve space for vertical toolbar when calculating column
   width's.<br />
   Possible values are: <pre>
        'auto'  : sheet try to estimate the need of scrollbar.
        'true'  : space for scrollbar is reserved.
        'false' : no space is reserved.
        </pre>
  <br />Default: <code>auto</code><br />Allowed Values: <code>auto,true,false</code>
  */
  public java.lang.String getForceVerticalScrollbar() {
    java.lang.String forceVerticalScrollbar = (java.lang.String) getStateHelper().eval(PropertyKeys.forceVerticalScrollbar);
    if (forceVerticalScrollbar != null) {
      return forceVerticalScrollbar;
    }
    return "auto";
  }

  public void setForceVerticalScrollbar(java.lang.String forceVerticalScrollbar) {
    getStateHelper().put(PropertyKeys.forceVerticalScrollbar, forceVerticalScrollbar);
  }

  public org.apache.myfaces.tobago.layout.Measure getMaximumHeight() {
    Object object = getStateHelper().eval(PropertyKeys.maximumHeight);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMaximumHeight(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMaximumHeight(org.apache.myfaces.tobago.layout.Measure maximumHeight) {
    getStateHelper().put(PropertyKeys.maximumHeight, maximumHeight);
  }

  /**
  This attribute is for internal use only.

  */
  public java.lang.Integer getVerticalIndex() {
    Number value  = (Number) getStateHelper().eval(PropertyKeys.verticalIndex);
    if (value != null) {
      return value.intValue();
    }
    return null;
  }

  public void setVerticalIndex(java.lang.Integer verticalIndex) {
    getStateHelper().put(PropertyKeys.verticalIndex, verticalIndex);
  }

  public org.apache.myfaces.tobago.layout.Measure getMinimumWidth() {
    Object object = getStateHelper().eval(PropertyKeys.minimumWidth);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMinimumWidth(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMinimumWidth(org.apache.myfaces.tobago.layout.Measure minimumWidth) {
    getStateHelper().put(PropertyKeys.minimumWidth, minimumWidth);
  }

  public org.apache.myfaces.tobago.layout.Measure getMarginTop() {
    Object object = getStateHelper().eval(PropertyKeys.marginTop);
    if (object != null) {
       return Measure.valueOf(object);
    }
    return getRendererType() != null ? ((LayoutComponentRenderer) getRenderer(getFacesContext())).getMarginTop(getFacesContext(), this) : Measure.ZERO;
  }

  public void setMarginTop(org.apache.myfaces.tobago.layout.Measure marginTop) {
    getStateHelper().put(PropertyKeys.marginTop, marginTop);
  }

  public Object saveState(FacesContext context) {
    currentMarkup = null;
    return super.saveState(context);
  }

}